#include <iostream>
#include "deleter_defs.h"
using namespace std;

class A {
public:
	explicit A(string str) : str(move(str)) {}
	friend ostream& operator<<(ostream& o, const A& a) {
		return o << a.str;
	}

private:
	string str;
};

int main() {
	int n = 12;
	auto int_heap_ptr = make_unique_delete(new int(24));
	auto int_stack_ptr = make_unique_no_delete(&n);
	cout << *int_heap_ptr << endl;
	cout << *int_stack_ptr << endl;

	*int_heap_ptr = 56;
	*int_stack_ptr = 67;
	cout << *int_heap_ptr << endl;
	cout << *int_stack_ptr << endl;
	cout << endl;

	A a("stack"s);
	auto a_heap_ptr = make_unique_delete(new A("heap"s));
	auto a_stack_ptr = make_unique_no_delete(&a);
	cout << *a_heap_ptr << endl;
	cout << *a_stack_ptr << endl;
	cout << endl;
}

