#include <memory>
#include <iostream>
using namespace std;

class Fraction {

public:
	explicit Fraction(int numerator = 0, int denominator = 1) :
		numerator{numerator}, denominator{denominator} {
		cout << "Fraction()" << endl;
	}

	~Fraction() {
		cout << "~Fraction()" << endl;
	}

	friend ostream& operator<<(ostream& out, const Fraction &fraction) {
		out << fraction.numerator << '/' << fraction.denominator;
		return out;
	}

private:
	int numerator{0};
	int denominator{1};
};

int main() {
	{
		// Create a single dynamically allocated Fraction with numerator 3 and denominator 5
		// We can also use automatic type deduction to good effect here
		auto fraction{make_unique<Fraction>(3, 5)};
		cout << *fraction << endl;
	}
	cout << endl;

	{
		// Create a dynamically allocated array of Fractions of length 4
		auto fraction_array{ make_unique<Fraction[]>(4) };
		for (int i = 0; i < 4; ++i) {
			cout << fraction_array[i] << " ";
		}
		cout << endl;
	}
	return 0;
}

